% clear; 
% close all; 
% clc

%% Function to be minimized

D=8; %number of variables

fobj=@(k) FitnessFunction(k);
% objf=inline('4*x1^2-2.1*x1^4+(x1^6)/3+x1*x2-4*x2^2+4*x2^4','x1','x2');
% objf=vectorize(objf);

%% Initialization of DE parameters
% N=50; %population size (total function evaluations will be itmax*N, must be>=5)
% itmax=200;
% F=0.5; CR=0.95; %mutation and crossover ratio  DA CONTROLLARE

%% Problem bounds
% LB=zeros(N,D);
% UB=ones(N,D);

% a(1:N,1)=-1.9; b(1:N,1)=1.9; %bounds on variable x1
% a(1:N,2)=-1.1; b(1:N,2)=1.1; %bounds on variable x2
d=(UB-LB);

basemat=repmat(int8(linspace(1,N,N)),N,1); %used later
basemat2=repmat(int8(linspace(1,D,D)),N,1); %used later

% numOpt=input('How many optimization do you like to do? ');
% numOpt=10;
xbest=zeros(numOpt,8);

for ii=1:numOpt
%Random initialization of positions
tic
x=LB+d.*rand(N,D);

%Evaluate objective for all particles
% fx=objf(x(:,1),x(:,2));

fx=zeros(N,1);

    for i=1:N
        fx(i)=fobj(x(i,:));
    end

%Find best
[fxbest,ixbest]=min(fx);
xbest(ii,:)=x(ixbest,:);
xbestit=repmat(2,itmax,D);

%Iterate
    for it=1:itmax
        disp(['Iteration number ',num2str(it),' of the optimization number ',num2str(ii)])

        permat=bsxfun(@(x,y) x(randperm(y(1))),basemat',N(ones(N,1)))';

        %Generate donors by mutation
%     v(1:N,1:D)=repmat(xbest,N,1)+F*(x(permat(1:N,1),1:D)-x(permat(1:N,2),1:D));
        v=repmat(xbest(ii,:),N,1)+F*(x(permat(:,1),:)-x(permat(:,2),:));

        %Perform recombination
        r=repmat(randi([1 D],N,1),1,D); %% randi fornisce una distribuzione uniforme discreta pseudorandom. PERCH PSEUDO!?
        muv = ((rand(N,D)<CR) + (basemat2==r)) ~= 0;
        mux = 1-muv; %negazione di muv
%     u(1:N,1:D)=x(1:N,1:D).*mux(1:N,1:D)+v(1:N,1:D).*muv(1:N,1:D);
        u=abs(x.*mux+v.*muv);

        %Greedy selection
        fu=zeros(N,1);
        
            parfor iii=1:N
                fu(iii)=fobj(u(iii,:));
            end
    
        idx=fu<fx;
        fx(idx)=fu(idx); %sostituisco i valori pi bassi dell'errore trovato nella funzione fx
        x(idx,:)=u(idx,:); %sostiuisco il vettore pi performante a quello meno performante

        
        %Find best
        [fxbest(it,1),ixbest]=min(fx);
        xbest(ii,:)=x(ixbest,:);
        xbestit(it,:)=x(ixbest,:);
%         disp(xbestit(it,:));
   
%         if it>2
%             
%             stopCrit=mean(abs(xbestit(it,:)-xbestit(it-1,:)));
%             if stopCrit<1e-6
%                 it=itmax;
%             end
%             
%         end
            %% Stopping criteria
            %it>20 &&
%         if fxbest(it,1)<1e-3 
%             crit=fxbest(it-1,1)-fxbest(it,1);
%             if crit<1e-12
%                  break
%             end
%         end
        
    end %end loop on iterations

save('Results_DE','xbest')
% [xbest,fxbest]
toc
end

