%% Script dei dati in condizioni nominali
%   Dati di targa riferiti al Brusless DC_Servomotor 4490H048BS

% Definizione parametri di guasto per eccentricit (NON MODIFICARE)



DT=2*5e-7;                      % Ampiezza passo d'integrazione (1e-6 x SMEMevo3)[s]
TiBr=.5;%0.2;                   % Tempo di simulazione

TimeCom=[0 0.1 0.1+DT TiBr];    % Vettore tempo
Com=[0 0 0.1 0.1];              % Vettore comando


%% Filtri Numerici x Vi0 e Ii

tauFiltro=10e-5;    %7e-5       %Costante di tempo filtro passa basso


%%  Modello cinematica complessiva Riduttore con Giochi

tau=2e-3;                       % Rapporto di tramissione complessivo EMA [#]

        
        BLKal=1e-5;             % Backlash Width (espresso in albero lento) [rad]
        BLK=(BLKal/tau)*B;

%% Caratteristiche Controller del ServoMotore

Gprop=G*1e5;                      % Guadagno proporzionale del controllore del BLDC
W_refMax=8000*pi/30;            % Limitatore di velocit nel controller

% Caratteristiche Controller PI del ServoMotore

GAP=0.05; %5 %0.75;%0.05;%0.1;       	% Guadagno Proporzionale Alimentatore/Amplificatore                     [N*m/(rad/s)]
GAI=0*10;                   % Guadagno Integrativo Alimentatore/Amplificatore                       [N*m/rad]
GAD=0*5e-5;                 % Guadagno Derivativo Alimentatore/Amplificatore                        [[N*m/(rad/s^2)]
ErIM=100;                   % Max Errore Integrativo                                                [rad/s]

Vmax=48;                    % Massima tensione di alimentazione Alimentatore/Amplificatore          [V]

I_Max=22.5;%6.8


        Knoise=0;           % Coefficiente moltiplicativo Rumore (0 - 1 - 10 - 100)


%%  Caratteristiche Elettromeccaniche DC Motor Particolareggiato

% Parametri caratteristici Motore BLDC - Dati Pubblicazione Lee - Ehsani

% kfi = 1/(85e-3);      % Inverso della costante di coppia                                      [A/Nm]
kt=0.0752;              % Costante di coppia                                                    [Nm/A]
% ke=7.871 [mV/rpm] = 7.871*30/pi/1000 [V/(rad/s)]
ke=0.0752;              % costante di fcem del motore                                           [V/(rad/s)]

ke=ke/2;

Vdc=Vmax;%2*Vmax;      	% tensione continua di alimentazione inverter                           [V]
Rs=2.130;               % resistenza fase-fase (es. Rab)                                        [Ohm]
Ls=720*1e-6;          	% induttanza fase-fase (es. Lab)                                        [H]
tauRLs=Ls/Rs;       	% Costante di tempo RL del DC Motor                                     [s]

Poli=4;                 % Numero espansioni polari BLDC per ogni fase                           [#]
P=Poli/2;               % Numero di paiapoli del BLDC per ogni fase                             [#]


TMM=1.689;               % Massima Coppia motrice erogata da DC Motor                           	[N*m]


% Controllore a isteresi del PWM, nel caso del modello con relay per la sua
% simulazione

hb =0.5; %0.1%1;%0.5;            	% Amp. banda d'isteresi in p.u. nel caso si usasse
                        % una rappresentazione del PWM per mezzo di relay
  
                        
%%  Modello FineCorsa BLDC Motor (M) e USER (U)

ThUmin=-1.0;%-0.02;
ThUmax=1.0;%0.72;
ThU0=0.0;

% ThMmin=ThUmin/tau;
% ThMmax=ThUmax/tau;
% ThM0=ThU0/tau;



%%  BLDC MOTOR - Modello Attrito Borello

        FSM=0.06*TMM;          	% Coefficiente Attrito Statico Utilizzatore Finale                    	[N*m]
        FDM=FSM/2;          	% Coefficiente Attrito Dinamico Utilizzatore Finale                 	[N*m]


        
%%  UTILIZZATORE - Modello Attrito Borello

        FSU=0.04*TMM;          	% Coefficiente Attrito Statico Utilizzatore Finale                    	[N*m]
        FDU=FSU/2;          	% Coefficiente Attrito Dinamico Utilizzatore Finale                 	[N*m]

        FrictIN=linspace(ThUmin,ThUmax,100);
        FrictOUT=ones(1,100);
%         FrictOUT=[1 1 1 1 1 1 1 1 1 1 1.05 1.1 1.2 1.4 1.99 1.97 2 2.2 3.8 5 5 5.2 15.2 15.3 16.6 17.2 25 25.5 26 22.23 22.5 12.4 12.2 2 1.6 1.6 1.6 1.2 1 1 1 1.05 1 1.2 1 1.99 1.97 2 2.2 2.8 3 4 4.2 4.2 5.3 5.6 5.2 5 15.5 16 16.23 25.5 25.4 15.2 15 14 14 14 13 13 2 2.05 2 1.2 2 1.99 1.97 1 1.2 1 1 1 1.2 1.2 1.3 1.6 1.2 1 1.5 1 1.23 1.5 1.4 1.2 1 1 1 1 1 1];



%%  SISTEMA 1 DOF BLDC + USER - Modello Attrito Borello

FST=F*(FSM+FSU);          	% Coefficiente Attrito Statico Utilizzatore Finale                    	[N*m]
FDT=F*(FDM+FDU);         	% Coefficiente Attrito Dinamico Utilizzatore Finale                 	[N*m]



%%  Caratteristiche Meccaniche BLDC + USER

JM=130e-007;        	% Momento d'inerzia del DC Motor (AV=albero veloce)              	[kg*m^2]
CM=30/pi*1e-6;          % Coefficiente di smorzamento viscoso dimensionale DC Motor (AV)   	[N*m*s/rad]

JU=12e-6;                % Momento d'inerzia utilizzatore ridotto all'albero veloce       	[kg*m^2]
CU=4.5070e-7;           % Coefficiente di smorzamento viscoso dimensionale utilizz.(AV)   	[N*m*s/rad]

JT=JM+JU;             	% Momento d'inerzia complessivo dell'EMA (AV=albero veloce)      	[kg*m^2]
CT=CM+CU;              	% Coeff. di smorzamento viscoso dimensionale compless. EMA (AV)   	[N*m*s/rad]


% %% Caratteristiche albero di trasmissione cedevole
% 
% Ktr=1e4;             	% Rigidezza torsionale albero di trasmissione lento                 	[N*m/rad]
% Ctr=0.1;             	% Coefficiente di smorzamento viscoso dimensionale struttura        	[N*m*s/rad]



%% Parametri Possibili Avarie BLDC

        Na=1; 
        Nb=1;
        Nc=1;

        Kea=ke*Na;
        Keb=ke*Nb;
        Kec=ke*Nc;

        zita=Z/0.42;                   % Rapporto fra x0 (disallineamento fra asse rotorico e statorico) e g0 (val. nominale gap rot-stat)

        
        
%% Caratteristiche EMA Semplificato - Trapezioidale (M)

% Controller

    GAPm1=G*1e5; %5e2/tau;

W_m=8000*pi/30;
GAPm2=0.05;

ktm=0.0752;                 % Costante di coppia - monitor                                            	[Nm/A]
    kem=0.07648;%0.0752;                 % costante di fem - monitor                                               	[V/(rad/s)]

    Vdcm=48;                    % tensione continua di alimentazione inverter - monitor                   	[V]

    Rm=2.130;                	% Resistenza ohmica delle bobine rotoriche DC Motor - monitor             	[Ohm]=[V/A]
                        	% Il suo valore  molto vicino a 2*Rs/sqrt(3)
                        
Lm=720*1e-6;                % Induttanza delle bobine rotoriche DC Motor - monitor                     	[H]=[V*s/A]
tauRLm=Lm/Rm;             	% Costante di tempo RL del DC Motor - monitor                             	[s]

    GM=0.07322;%0.0752;                  % Guadagno in coppia DC Motor - monitor                                    	[N*m/A]
TMMm=1.689;               	% Massima Coppia motrice erogata da DC Motor - monitor                     	[N*m]

JMm=2.5e-5;                 % Momento d'inerzia complessivo dell'EMA (AV=albero veloce) - monitor      	[kg*m^2]
CMm=5.172e-5;%5e-5;                 % Coeff. di smorzamento viscoso dimensionale compless. EMA (AV) - monitor  	[N*m*s/rad]



%% Caratteristiche EMA Semplificato - Sinusoidale (M)
% 
% % Controller
% GAPms1=1e6;
% W_ms=1000;
% GAPms2=0.005;
% 
% ktms=0.0419;               	% Costante di coppia - monitor                                            	[Nm/A]
% kems=0.0419;               	% costante di fem - monitor                                               	[V/(rad/s)]
% 
% Vdcms=0.7071*24;           	% tensione continua di alimentazione inverter - monitor                   	[V]
% 
% Rms=1.885*0.348;           	% Resistenza ohmica delle bobine rotoriche DC Motor - monitor                   [Ohm]=[V/A]
% Lms=2*0.314e-3;               % Induttanza delle bobine rotoriche DC Motor - monitor                     	[H]=[V*s/A]
% tauRLms=Lms/Rms;              % Costante di tempo RL del DC Motor - monitor                             	[s]
% 
% GMs=1.5*0.0419*P;%0.0850;     % Guadagno in coppia DC Motor - monitor                                         [N*m/A]
% TMMm=1.89;                    % Massima Coppia motrice erogata da DC Motor - monitor                     	[N*m]
% 
% JMm=3.8000e-005;              % Momento d'inerzia complessivo dell'EMA (AV=albero veloce) - monitor      	[kg*m^2]
% CMm=0.002;                    % Coeff. di smorzamento viscoso dimensionale compless. EMA (AV) - monitor  	[N*m*s/rad]
% 
% % FDTms=0.0567;
% % KFDTms=1e2;
% 
% 
% 
%%  Calcolo dei coefficienti del modello EM ohmico-induttivo (particolareggiato)

        
%         disp('Elenco Guasti Considerati')
%         disp(' ')
%         disp(['N Paiapoli P = ',num2str(P)])
%         disp(['Knoise = ',num2str(Knoise)])
%         disp(['FST = ',num2str(FST)])
%         disp(['FDT = ',num2str(FDT)])
%         disp(['BLK = ',num2str(BLK)])
%         disp(['GAP = ',num2str(GAP)])
%         disp(' ')
%         
%         disp(['Na = ',num2str(Na)])
%         disp(['Nb = ',num2str(Nb)])
%         disp(['Nc = ',num2str(Nc)])
%         disp(' ')
        
        Rab=Rs/2*(Na+Nb);
        Lab=Ls/2*(Na^2+Nb^2);
       

        Rbc=Rs/2*(Nb+Nc);
        Lbc=Ls/2*(Nb^2+Nc^2);


        Rca=Rs/2*(Nc+Na);
        Lca=Ls/2*(Nc^2+Na^2);
        
        
      	Ra=Rs/2*Na;
        La=Ls/2*Na^2;
       

        Rb=Rs/2*Nb;
        Lb=Ls/2*Nb^2;


        Rc=Rs/2*Nc;
        Lc=Ls/2*Nc^2;
        
        
%         disp(['Rs  = ',num2str(Rs)])
%         disp(['Rab = ',num2str(Rab)])
%         disp(['Rbc = ',num2str(Rbc)])
%         disp(['Rca = ',num2str(Rca)])
%         disp(' ')
%         
%         disp(['Ls  = ',num2str(Ls)])
%         disp(['Lab = ',num2str(Lab)])
%         disp(['Lbc = ',num2str(Lbc)])
%         disp(['Lca = ',num2str(Lca)])
%         disp(' ')
%         
%       	disp(['Rs = ',num2str(Rs)])
%         disp(['Ra = ',num2str(Ra)])
%         disp(['Rb = ',num2str(Rb)])
%         disp(['Rc = ',num2str(Rc)])
%         disp(' ')
%         
%         disp(['Ls = ',num2str(Ls)])
%         disp(['La = ',num2str(La)])
%         disp(['Lb = ',num2str(Lb)])
%         disp(['Lc = ',num2str(Lc)])
%         disp(' ')
        
        
%% Implementazione Guasto CC Bobina Statorica nel modello Monitor_EVO

%         Nequiv=(Na+Nb+Nc)/3;
% 
%         Rm=Rm*Nequiv;
%         GM=GM*Nequiv;
%         kem=kem*Nequiv;
%         tauRLm=tauRLm*Nequiv;
        
%         disp('Parametri Elettrici Monitor_EVO')
%         disp(['Nequiv = ',num2str(Nequiv),' (1 = NC - 0 = CC Coils)'])


