%%  Caratteristiche Comparatore-Amplificatore e Alimentazione BLDC
%   Dati riferiti al Brusless DC_Servomotor 4490H048BS

%         Com4=1;
%         Com1=0; Com2=0; Com3=0; Com5=0; Com6=0;
%  		F=1;
% 		B=1;
% 		Na=1;
% 		Nb=1;
% 		Nc=1;
% 		Z=0;
% 		phi=0;
% 		G=0.5;


Z=0;        %Parametro dipendente dall'entit del guasto per eccentricit
phi=0;      %Sfasamento dell'eccentricit del rotore

% clc

DT=2*5e-7;             	% Ampiezza passo d'integrazione (1e-6 x SMEMevo3)[s]
TiBr=.5;%0.2;           % Tempo di simulazione

TimeCom=[0 0.1 0.1+DT TiBr];
Com=[0 0 0.1 0.1];


%%  Filtri Numerici x Vi0 e Ii

tauFiltro=10e-5;%7e-5       %Costante di tempo filtro passa basso


%%  Modello cinematica complessiva Riduttore con Giochi

tau=2e-3;                       % Rapporto di tramissione complessivo EMA                               [#]

        
        BLKal=1e-5;                       % Backlash Width (espresso in albero lento)                             [rad]
        BLK=BLKal/tau;


%% Caratteristiche Controller PI del ServoMotore

Gprop=1e5; %5e2/tau;
W_refMax=8000*pi/30;%6060*pi/30%;       %limitatore di velocit nel controller

% Caratteristiche Controller PI del ServoMotore

GAP=0.05; %5 %0.75;%0.05;%0.1;       	% Guadagno Proporzionale Alimentatore/Amplificatore                     [N*m/(rad/s)]
GAI=0*10;                   % Guadagno Integrativo Alimentatore/Amplificatore                       [N*m/rad]
GAD=0*5e-5;                 % Guadagno Derivativo Alimentatore/Amplificatore                        [[N*m/(rad/s^2)]
ErIM=100;                   % Max Errore Integrativo                                                [rad/s]

Vmax=48;                    % Massima tensione di alimentazione Alimentatore/Amplificatore          [V]

I_Max=22.5;%6.8


        Knoise=0;           % Coefficiente moltiplicativo Rumore (0 - 1 - 10 - 100)


%%  Caratteristiche Elettromeccaniche DC Motor Particolareggiato

% Parametri caratteristici Motore BLDC - Dati Pubblicazione Lee - Ehsani

kt=0.0752;              % Costante di coppia                                                    [Nm/A]
ke=0.0752;              % costante di fcem del motore                                           [V/(rad/s)]

ke=ke/2;

Vdc=Vmax;%2*Vmax;      	% tensione continua di alimentazione inverter                           [V]
Rs=2.130;               % resistenza fase-fase (es. Rab)                                        [Ohm]
Ls=720*1e-6;          	% induttanza fase-fase (es. Lab)                                        [H]
tauRLs=Ls/Rs;       	% Costante di tempo RL del DC Motor                                     [s]

Poli=4;                 % Numero espansioni polari BLDC per ogni fase                           [#]
P=Poli/2;               % Numero di paiapoli del BLDC per ogni fase                             [#]


TMM=1.689;               % Massima Coppia motrice erogata da DC Motor                           	[N*m]


% Controllore a isteresi del PWM, nel caso del modello con relay per la sua
% simulazione

hb =0.5; %0.1%1;%0.5;   % Amp. banda d'isteresi in p.u. nel caso si usasse
                        % una rappresentazione del PWM per mezzo di relay
  
                        
%%  Modello FineCorsa BLDC Motor (M) e USER (U)

ThUmin=-1.0;%-0.02;
ThUmax=1.0;%0.72;
ThU0=0.0;

%%  BLDC MOTOR - Modello Attrito Borello

        FSM=0.06*TMM;          	% Coefficiente Attrito Statico Utilizzatore Finale                    	[N*m]
        FDM=FSM/2;          	% Coefficiente Attrito Dinamico Utilizzatore Finale                 	[N*m]


        
%%  UTILIZZATORE - Modello Attrito Borello

        FSU=0.04*TMM;          	% Coefficiente Attrito Statico Utilizzatore Finale                    	[N*m]
        FDU=FSU/2;          	% Coefficiente Attrito Dinamico Utilizzatore Finale                 	[N*m]

        FrictIN=linspace(ThUmin,ThUmax,100);
        FrictOUT=ones(1,100);



%%  SISTEMA 1 DOF BLDC + USER - Modello Attrito Borello

FST=(FSM+FSU);          	% Coefficiente Attrito Statico Utilizzatore Finale                    	[N*m]
FDT=(FDM+FDU);         	% Coefficiente Attrito Dinamico Utilizzatore Finale                 	[N*m]



%%  Caratteristiche Meccaniche BLDC + USER

JM=130e-7;        	% Momento d'inerzia del DC Motor (AV=albero veloce)              	[kg*m^2]
CM=30/pi*1e-6;          % Coefficiente di smorzamento viscoso dimensionale DC Motor (AV)   	[N*m*s/rad]

JU=12e-6;                % Momento d'inerzia utilizzatore ridotto all'albero veloce       	[kg*m^2]
CU=4.5070e-7;           % Coefficiente di smorzamento viscoso dimensionale utilizz.(AV)   	[N*m*s/rad]

JT=JM+JU;             	% Momento d'inerzia complessivo dell'EMA (AV=albero veloce)      	[kg*m^2]
CT=CM+CU;              	% Coeff. di smorzamento viscoso dimensionale compless. EMA (AV)   	[N*m*s/rad]



%% Parametri Possibili Avarie BLDC

        Na=1; %0.95%0.95;
        Nb=1;
        Nc=1;

        Kea=ke*Na;
        Keb=ke*Nb;
        Kec=ke*Nc;

        zita=Z/0.42;                   % Rapporto fra x0 (disallineamento fra asse rotorico e statorico) e g0 (val. nominale gap rot-stat)

        
        
%% Caratteristiche EMA Semplificato - Trapezioidale (M)

% Controller

    GAPm1=1e5; %5e2/tau;

W_m=8000*pi/30;
GAPm2=0.05;

ktm=0.0752;                 % Costante di coppia - monitor                                            	[Nm/A]
    kem=0.07648;%0.0752;                 % costante di fem - monitor                                               	[V/(rad/s)]

    Vdcm=48;                    % tensione continua di alimentazione inverter - monitor                   	[V]

    Rm=2.130;                	% Resistenza ohmica delle bobine rotoriche DC Motor - monitor             	[Ohm]=[V/A]
                        	% Il suo valore  molto vicino a 2*Rs/sqrt(3)
                        
Lm=720*1e-6;                % Induttanza delle bobine rotoriche DC Motor - monitor                     	[H]=[V*s/A]
tauRLm=Lm/Rm;             	% Costante di tempo RL del DC Motor - monitor                             	[s]

    GM=0.07322;%0.0752;                  % Guadagno in coppia DC Motor - monitor                                    	[N*m/A]
TMMm=1.689;               	% Massima Coppia motrice erogata da DC Motor - monitor                     	[N*m]

JMm=2.5e-5;                 % Momento d'inerzia complessivo dell'EMA (AV=albero veloce) - monitor      	[kg*m^2]
CMm=5.172e-5;%5e-5;                 % Coeff. di smorzamento viscoso dimensionale compless. EMA (AV) - monitor  	[N*m*s/rad]


%%  Calcolo dei coefficienti del modello EM ohmico-induttivo (particolareggiato)

        
        Rab=Rs/2*(Na+Nb);
        Lab=Ls/2*(Na^2+Nb^2);
       

        Rbc=Rs/2*(Nb+Nc);
        Lbc=Ls/2*(Nb^2+Nc^2);


        Rca=Rs/2*(Nc+Na);
        Lca=Ls/2*(Nc^2+Na^2);
        
        
      	Ra=Rs/2*Na;
        La=Ls/2*Na^2;
       

        Rb=Rs/2*Nb;
        Lb=Ls/2*Nb^2;


        Rc=Rs/2*Nc;
        Lc=Ls/2*Nc^2;
        
        