function [err]=FitnessFunction(k)
run('EMA_Re_DAT_NC')
flag=1;

%% Ottimizzazione


    load('I3equiv.mat')
    load('AuxiliaryFiles\errChirpNC.mat')


% attrito

    F=interp1([0 1],[1 3],k(1));


    FST=F*(FSM+FSU);
    FDT=F*(FDM+FDU);

% backlash

    B=interp1([0 1],[1 100],k(2));
%     BLK=MatriceParametri(7);
%     BLKa1=MatriceParametri(8);
%     tau=MatriceParametri(9);
    
    BLK=(BLKal/tau)*B;

% CC spire

    Na=interp1([0 1],[1 0],k(3));
    Nb=interp1([0 1],[1 0],k(4));
    Nc=interp1([0 1],[1 0],k(5));

    
    if Na==0, Na=1e-2; end % per evitare che il calcolo esploda con 2 fasi completamente in CC
    if Nb==0, Nb=1e-2; end
    if Nc==0, Nc=1e-2; end    
    
    tauRLm=tauRLm*(Na+Nb+Nc)/3;
    
% eccentricit rotore

	Z=interp1([0 1],[0 0.42],k(6));
    phi=interp1([0 1],[-pi pi],k(7));
% 	Z=interpn([0 1],[0 0.42],k(6),'nearest');
%     phi=interpn([0 1],[-pi pi],k(7),'nearest');
%     
% guadagno proporzionale
    
    GAPm1=interp1([0 1],[0.5e5 1.5e5],k(8));
%       GAPm1=interpn([0 1],[0.5e5 1.5e5],k(8),'nearest');

% simulazione modello semplificato
try
    options = simset('SrcWorkspace','current');
    sim('monitorModelNew2',[],options)
       
%     sim('monitorModelNew')
catch
    flag=0;
end

if flag==0
    err=10000;
else
    %Errore chirp
%     errChirpNC = (I3equiv(2,:)-corrMonitor(:,1)');
    
% calcolo errore corrente

    y1=I3equiv(2,:);
%     size(corrMonitor')
%     size(errChirpNC)
    y2=corrMonitor'+errChirpNC;
    
%     rmsNC=2540.5;       %  il valore RMS della derivata dy1/dt nelle condizioni nominali
%     rmsNC=5633.8;       %valore RMS della dy1/dt ricalcolata da me per lo step
    rmsNC=2.5353e+03;   %valore RMS della dy1/dt ricalcolata da me per il chirp
    
    dy=gradient(y1)/rmsNC/DT;
%     dy=gradient(y1)/10/DT;
% rms(dy)

    err=sum((y1-y2).^2./(dy.^2+1))*10*DT;       % 10*DT  il sampling time, equivale a dividere per il numero di punti
    



end
end
