function [err]=FitnessFunction(k)
run('EMA_Re_DAT_NC')
flag=1;

%% Ottimizzazione

% k(1)  l'attrito normalizzato (=0 --> condizioni nominali, =1 --> 3*condizioni nominali)
% k(2)  il backlash (=0 --> condizioni nominali, =1 --> 100*condizioni nominali)
% k(3)  il cortocircuito della fase A (=0 --> Na=1, condizioni nominali, =1 --> Na=0.8)
% k(4)  il cortocircuito della fase B (=0 --> Na=1, condizioni nominali, =1 --> Na=0.8)
% k(5)  il cortocircuito della fase C (=0 --> Na=1, condizioni nominali, =1 --> Na=0.8)
% k(6)  l'eccentricit del rotore (k(6)=zita)
% k(7)  la fase dell'eccentricit (k(7)=0 --> phi=-pi, k(7)=1 --> phi=pi)
% k(8)  il guadagn proporzionale (k(8)=0 --> Gprop=0.5e5, k(8)=1 --> Gprop=1.5e5)

% evalin('base','EMA_Germana_DAT')

%     global FSM FDM FSU FDU FST FDT
%     global BLK BLKal tau
%     global Na Nb Nc Rm GM kem tauRLm
% 	global Z phi
%     global GAPm1
%     global DT

    load('I3equiv.mat')
    load('AuxiliaryFiles\errChirpNC.mat')
%     load('Dati_Simulaz')
    
%     load db\chirpF+BLK+Na.mat      %[.5 .101 .2 0 0 0 0] 
%     load db\chirpNa=0.5.mat
%     load db\chirpF+BLK+Na5+Z.mat      %[.5 .101 .2 0 0 .8 .5]         % contiene Dati_Simulaz (risultati del modello di riferimento)
%     load('correzioneChirp.m')                     % contiene errChirpNC (errore del modello semplificato in condizioni nominali)

%     load db\chirpF+BLK+Z.mat      %[.5 .101 0 0 0 .8 .5]
%     load db\chirpNC.mat
%     load db\CHIRPFB
%     load db\chirpF+BLK+Na5+Z.mat  %[.5 .101 .5 0 0 .2 .5 .5]

%     load db\chirpF=2.mat
%     load db\chirpBLK=0.192.mat
%     load db\chirpNa=0.9.mat
%     load db\chirpZ=0.2.mat
%     load db\chirpG=0.4.mat
% 
%     load db\correzioneChirp.mat
    
%     evalin('base','load db\CHIRPFB.mat')
    
%     disp(['atttrito:  ',num2str(k(1))])      % cos durante l'ottimizzazione si vede cosa sta facendo optimtool
%     disp(['backlash:  ',num2str(k(2)),' (B = ',num2str(interp1([0 1],[1 100],k(2))),')'])
%     disp(['CC fase A: ',num2str(k(3)),' (Na = ',num2str(interp1([0 1],[1 0],k(3))),')'])
%     disp(['CC fase B: ',num2str(k(4)),' (Nb = ',num2str(interp1([0 1],[1 0],k(4))),')'])
%     disp(['CC fase C: ',num2str(k(5)),' (Nc = ',num2str(interp1([0 1],[1 0],k(5))),')'])
%     disp(['zita:      ',num2str(k(6))])
%     disp(['fase:      ',num2str(k(7)),' (phi = ',num2str(interp1([0 1],[-pi pi],k(7))),')'])
%     disp(['gain:      ',num2str(k(8)),' (GAPm1 = ',num2str(interp1([0 1],[0.5e5 1.5e5],k(8))),')'])
%     disp(' ')

% attrito

    F=interp1([0 1],[1 3],k(1));

    FST=F*(FSM+FSU);
    FDT=F*(FDM+FDU);

% backlash

    B=interp1([0 1],[1 100],k(2));

    
    BLK=(BLKal/tau)*B;

% CC spire

    Na=interp1([0 1],[1 0],k(3));
    Nb=interp1([0 1],[1 0],k(4));
    Nc=interp1([0 1],[1 0],k(5));

    
    if Na==0, Na=1e-2; end % per evitare che il calcolo esploda con 2 fasi completamente in CC
    if Nb==0, Nb=1e-2; end
    if Nc==0, Nc=1e-2; end    
    
    tauRLm=tauRLm*(Na+Nb+Nc)/3;
    
% eccentricit rotore

	Z=interp1([0 1],[0 0.42],k(6));
    phi=interp1([0 1],[-pi pi],k(7));

%     
% guadagno proporzionale
    
    GAPm1=interp1([0 1],[0.5e5 1.5e5],k(8));

% simulazione modello semplificato
try
    options = simset('SrcWorkspace','current');
    sim('monitorModelNew2',[],options)
       
%     sim('monitorModelNew')
catch
    flag=0;
end

if flag==0
    err=10000;
else

    
% calcolo errore corrente

    y1=I3equiv(2,:);
%     size(corrMonitor')
%     size(errChirpNC)
    y2=corrMonitor'+errChirpNC;
    
%     rmsNC=2540.5;       %  il valore RMS della derivata dy1/dt nelle condizioni nominali
%     rmsNC=5633.8;       %valore RMS della dy1/dt ricalcolata da me per lo step
    rmsNC=2.5353e+03;   %valore RMS della dy1/dt ricalcolata da me per il chirp
    
    dy=gradient(y1)/rmsNC/DT;
%     dy=gradient(y1)/10/DT;
% rms(dy)

    err=sum((y1-y2).^2./(dy.^2+1))*10*DT;       % 10*DT  il sampling time, equivale a dividere per il numero di punti
    


end
end
