
%% Parameters from Main script
% SearchAgents_no=50;
% Max_iter=200;
% dim=8;
% lb=zeros(1,dim);
% ub=ones(1,dim);
fobj=@FitnessFunction;

% initialize alpha, beta, and delta_pos
   
%Initialize the positions of search agents
Positions=GWO_initialization(SearchAgents_no,dim,ub,lb);

% Convergence_curve=zeros(1,Max_iter);

% Loop counter

%% Main loop

% numOpt=input('How many optimizations do you like to do?');

Z=zeros(numOpt,dim);

for ii=1:numOpt %numero di ottimizzazioni
    
    tic
    
    Alpha_pos=zeros(SearchAgents_no,dim);
    Alpha_score=1e6*ones(SearchAgents_no,1); %change this to -inf for maximization problems

    Beta_pos=zeros(SearchAgents_no,dim);
    Beta_score=1e6*ones(SearchAgents_no,1); %change this to -inf for maximization problems

    Delta_pos=zeros(SearchAgents_no,dim);
    Delta_score=1e6*ones(SearchAgents_no,1); %change this to -inf for maximization problems
    
    Alpha_score_best=1e6*ones(Max_iter,1);
    Alpha_pos_best=repmat(10,Max_iter,dim); %metto 2 cos so che sono numeri impossibili

    
    for l=1:Max_iter %numero massimo di iterazioni in ogni ottimizzazione
    
        disp(['Iteration number ',num2str(l),' of the optimization number ',num2str(ii)])
   
            parfor i=1:SearchAgents_no          
        
               % Return back the search agents that go beyond the boundaries of the search space
                Flag4ub=Positions(i,:)>ub;
                Flag4lb=Positions(i,:)<lb;
                Positions(i,:)=(Positions(i,:).*(~(Flag4ub+Flag4lb)))+ub.*Flag4ub+lb.*Flag4lb;               

                % Calculate objective function for each search agent
                fitness(i,1)=fobj(Positions(i,:));
            end
            parfor i=1:SearchAgents_no
            % Update Alpha, Beta, and Delta
                if fitness(i,1)<Alpha_score(i) 
                    Alpha_score(i)=fitness(i,1); % Update alpha
                    Alpha_pos(i,:)=Positions(i,:);

                elseif fitness(i,1)>Alpha_score(i) && fitness(i,1)<Beta_score(i)
                    Beta_score(i)=fitness(i,1); % Update beta
                    Beta_pos(i,:)=Positions(i,:);

                elseif fitness(i,1)>Alpha_score(i) && fitness(i,1)>Beta_score(i) && fitness(i,1)<Delta_score(i) 
                    Delta_score(i)=fitness(i,1); % Update delta
                    Delta_pos(i,:)=Positions(i,:);
                end
            end   

    a=2-l*((2)/Max_iter); % a decreases linearly fron 2 to 0
    
    % Update the Position of search agents including omegas
        for i=1:SearchAgents_no
            for j=1:dim     
                       
                r1=rand(); % r1 is a random number in [0,1]
                r2=rand(); % r2 is a random number in [0,1]

                A1=2*a*r1-a; % Equation (3.3)
                C1=2*r2; % Equation (3.4)

                D_alpha=abs(C1*Alpha_pos(i,j)-Positions(i,j)); % Equation (3.5)-part 1
                X1=Alpha_pos(i,j)-A1*D_alpha; % Equation (3.6)-part 1

                r1=rand();
                r2=rand();

                A2=2*a*r1-a; % Equation (3.3)
                C2=2*r2; % Equation (3.4)

                D_beta=abs(C2*Beta_pos(i,j)-Positions(i,j)); % Equation (3.5)-part 2
                X2=Beta_pos(i,j)-A2*D_beta; % Equation (3.6)-part 2       

                r1=rand();
                r2=rand(); 

                A3=2*a*r1-a; % Equation (3.3)
                C3=2*r2; % Equation (3.4)

                D_delta=abs(C3*Delta_pos(i,j)-Positions(i,j)); % Equation (3.5)-part 3
                X3=Delta_pos(i,j)-A3*D_delta; % Equation (3.5)-part 3             

                Positions(i,j)=(X1+X2+X3)/3;% Equation (3.7)
            
            end
        end
    
        [Alpha_score_best(l,1),Best_index]=min(Alpha_score);
        Alpha_pos_best(l,:)=Alpha_pos(Best_index,:);    
        
        

        %% Stopping criteria
%         l>20 &&
%         if Alpha_score_best(l,1)<1e-3 
%             crit=Alpha_score_best(l-1,1)-Alpha_score_best(l,1);
%             if crit<1e-16
%                  break
%             end
%         end
    
    
    end
   
    [best_solution(ii), indexx]=min(Alpha_score_best);
    Z(ii,:)=Alpha_pos_best(indexx,:);
    save('GWO_Results','Z')

toc
    
end
    







            