%% Introduzione 

clear
close all
clc

disp('%%%%%%%%%%%%%%-------    Fault parameters optimization for EMA model    -------%%%%%%%%%%%%%%')
disp(' ')
disp('Script developed by Stefano Re, with Pier Carlo Berri and Matteo Dalla Vedova (DIMEAS Polito)')
disp(' ')

%% Command choice

% User could choice the type of the command for the EMA. Commands are
% expressed in [rad]:

% Step= 1[rad], applied at 0.01s
% descrivili tutti

a=input('Choose the command: (1=step, 2=ramp, 3=sinusoidal, 4=chirp): ');

if a==1
        Com1=1;
        Com2=0; Com3=0; Com4=0; Com5=0; Com6=0;              %I valore Com verranno utilizzati come parametri booleani per attivare selettivamente un comando (vedi simulink)
elseif a==2
        Com2=1;
        Com1=0; Com3=0; Com4=0; Com5=0; Com6=0;
elseif a==3
        Com3=1;
        Com1=0; Com2=0; Com4=0; Com5=0; Com6=0;
elseif a==4
        Com4=1;
        Com1=0; Com2=0; Com3=0; Com5=0; Com6=0;
else
        disp('Do a valid choice!')
        clear
end


%% Optimization choice

OptChoice=input('Would you like to study a single-faulty or a multiple-faulty BLDC motor? (1=single, 2=multiple): ');
disp(' ');

if OptChoice==1

    %% Fault choice

    disp(' ')
    disp('Choose the fault you would like to introduce:')
    disp('1= Friction fault')
    disp('2= Backlash fault ')
    disp('3= Phase A short circuit fault')
    disp('4= Phase B short circuit fault')
    disp('5= Phase C short circuit fault')
    disp('6= Eccentricity parameter fault (zita) ')
    disp('7= Eccentricity phase fault ')
    disp('8= Gain fault ')
    disp(' ')

    b=input('Your choice: ');
    
    %Imposto i parametri e faccio girare il file dati con guasto

    if b==1
        F=input('Give a value for the friction [1 - 3] --> [NC - 3*NC]: ');         %Parametro moltiplicativo per l'attrito
        B=1;                                                                        %Parametro moltiplicativo per il backlash
        Z=0;                                                                        %Parametro dipendente dall'entit del guasto per eccentricit
        phi=0;                                                                      %Sfasamento dell'eccentricit del rotore
        G=1;                                                                        %Parametro moltiplicativo per il gain

        if F<1 || F>3
            disp('Do a valid choice!')
            clear
        else    
            run('EMA_Re_DAT')
        end
    elseif b==2
        F=1;
        B=input('Give a value for the backlash [1 - 100] --> [NC - 100*NC]: ');
        Z=0;
        phi=0;
        G=1;

        if B<1 || B>100
            disp('Do a valid choice!')
            clear
        else    
            run('EMA_Re_DAT')
        end
    elseif b==3
        F=1;
        B=1;
        Na=input('Give a value for the phase A short-circuit [1 - 0] --> [0% - 100%]: ');
        Nb=1;
        Nc=1;
        Z=0;
        phi=0;
        G=1;

        if Na<0 || Na>1
            disp('Do a valid choice!')
            clear
        else    
            run('EMA_Re_DAT2')
        end
    elseif b==4
        F=1;
        B=1;
        Na=1;
        Nb=input('Give a value for the phase B short-circuit [1 - 0] --> [0% - 100%]: ');
        Nc=1;
        Z=0;
        phi=0;
        G=1;

        if Nb<0 || Nb>1
            disp('Do a valid choice!')
            clear
        else    
            run('EMA_Re_DAT2')
        end
    elseif b==5
        F=1;
        B=1;
        Na=1;
        Nb=1;
        Nc=input('Give a value for the phase C short-circuit [1 - 0] --> [0% - 100%]: ');
        Z=0;
        phi=0;
        G=1;

        if Nc<0 || Nc>1
            disp('Do a valid choice!')
            clear
        else    
            run('EMA_Re_DAT2')
        end
    elseif b==6
        F=1;
        B=1;
        Z=input('Give a value for the Z [0 - 0.42]: ');
        phi=0;
        G=1;

        if Z<0 || Z>0.42
            disp('Do a valid choice!')
            clear
        else    
            run('EMA_Re_DAT')
        end
    elseif b==7
        F=1;
        B=1;
        Z=0;
        phi=input('Give a value for the eccentricity phase [-pi - +pi]: ');
        G=1;

        if phi<-pi || phi>pi
            disp('Do a valid choice!')
            clear
        else    
            run('EMA_Re_DAT')
        end
    elseif b==8
        F=1;
        B=1;
        Z=0;
        phi=0;
        G=input('Give a value for the gain [0.5 - 1.5] --> [0.5*NC - 1.5*NC]: ');

        if G<0.5 || G>1.5
            disp('Do a valid choice!')
            clear
        else    
            run('EMA_Re_DAT')
        end
    else 
        disp('Do a valid choice!')
        clear
    end

    % Termina la parte del guasto singolo

elseif OptChoice==2		%% Inizia guasto multiplo
    InputType=input('Would you like to introduce a random multiple fault (choose 1) or write the fault parameters by your own (choose 2)?: ');

    if InputType==1         %% Guasto multiplo random
		
		RandomFaultParams=rand(1,8);
        RandomFaultParams(:,1:6)=RandomFaultParams(:,1:6).^7;
        RandomFaultParams(:,8)=((RandomFaultParams(:,8)*2-1).^7+1)/2;
		disp(' ')
		disp(['The random fault vector is: ',mat2str(RandomFaultParams(:))])
        save('Random_fault', 'RandomFaultParams')
		disp(' ')
        

		F=2*(RandomFaultParams(1,1))+1;
		B=99*(RandomFaultParams(1,2))+1;
		Na=1-RandomFaultParams(1,3);
		Nb=1-RandomFaultParams(1,4);
		Nc=1-RandomFaultParams(1,5);
		Z=0.42*(RandomFaultParams(1,6));
		phi=RandomFaultParams(1,7);
		G=RandomFaultParams(1,8)+0.5;
   
        run('EMA_Re_DAT2');
        
    elseif InputType==2     %% Guasto multiplo introdotto
        
        disp(' ');
        F=2*input('Introduce the friction fault: ')+1;
		B=99*input('Introduce the backlash fault: ')+1;
		Na=1-input('Introduce the phase A short-circuit fault: ');
		Nb=1-input('Introduce the phase B short-circuit fault: ');
		Nc=1-input('Introduce the phase C short-circuit fault: ');
		Z=0.42*input('Introduce the eccentricity fault: ');
		phi=input('Introduce the eccentricity phase fault: ');
		G=input('Introduce the gain fault: ')+0.5;
        
        run('EMA_Re_DAT2');
        
    else
        disp('Do a valid choice!')
        clear       
    end        
    
                  
end                     %Termina la scelta del guasto
%% Simulation of the reference Model

sim('EMA_Re_EVO');              % This simulation creates I3equiv.mat (current file)

%% Optimizations

disp(' ')
disp('Choose the optimization algorithm: ')
disp('1= Genetic Algorithm')
disp('2= Particle Swarm Optimization')
disp('3= Differential Evolution')
disp('4= Greywolf Optimization')
disp('5= Dragonfly Algorythm')

c=input('Your choice: ');
disp(' ')
d=input('Would you like to parallelize the optimization? (1=yes, 2=no)');

%Parallelization of the optimizations

if d==1
    parpool
    Parp=true(1);
else
    Parp=false(1);
end

%Choose the optimization features


% For every set of input, I do 10 optimizations (heuristic!=deterministic)
numOpt=input('How many optimizations do you like to do?');

X=zeros(numOpt,8);
Y=zeros(numOpt,8);
popsize=input('Specify the population size: ');
numgen=input('Specify the number of generations: ');


for i=1:numOpt

     if c==1
        LB=zeros(1,8);
        UB=ones(1,8);
        disp(' ')
    	
        tic
        opt1=optimoptions(@ga,'Display','iter','PopulationSize',popsize,'Generations',numgen,'FunctionTolerance',1e-12, 'UseParallel',Parp);
%         'FitnessLimit',1e-3
        X(i,:)=ga(@FitnessFunction,8,[],[],[],[],LB,UB,[],[],opt1);
        toc

        save('Results_GA','X')
        
       
        
     elseif c==2
        LB=zeros(1,8);
        UB=ones(1,8);
        disp(' ')
    	disp(' ')

        tic
        opt2=optimoptions(@particleswarm,'Display','iter','SwarmSize',popsize,'MaxIterations',200,'FunctionTolerance',1e-12,'UseParallel',Parp);
%         'ObjectiveLimit',1e-3
        Y(i,:)=particleswarm(@FitnessFunction,8,LB,UB,opt2);
        toc

        save('Results_PSO','Y')
        
        
        
     elseif c==3
        N=input('Specify the population size: ');
        D=8;
        LB=zeros(N,D);
        UB=ones(N,D);
         
        
        itmax=input('Specify the maximum number of iterations: ');
        disp(' ');
        disp('CHOICE OF THE D.E. PARAMETERS:');
        F=input('Mutation ratio (F): ');
        CR=input('Crossover ratio (CR): ');

        run('DE_main');     %the "save" command is already inside the script (xbest)
        
        break
        
     elseif c==4
        SearchAgents_no=input('Specify the number of search agents: ');
        Max_iter=input('Specify the maximum number of iterations: ');
        dim=8;
        lb=zeros(1,dim);
        ub=ones(1,dim);
        
        run('GWO_remix');   %the "save" command is already inside the script (Z)

        break
     
     elseif c==5
     
        SearchAgents_no=input('Specify the number of search agents: ');
        Max_iter=input('Specify the maximum number of iterations: ');
        dim=8;
        lb=zeros(1,dim);
        ub=ones(1,dim);
        fobj=@FitnessFunction;
         
         run('runDa_mosa');
         
         break
    
      
     else
              
         disp('Do a valid choice!')
         break
     end
    
%    save('Results','X','Y')
end

disp(' ')
disp('Optimization successfully termined')
