clear all
close all
clc

%% Command

a=input('Choose the command: (1=step, 4=chirp): ');

if a==1
        Com1=1;
        Com2=0; Com3=0; Com4=0; Com5=0; Com6=0;              %I valore Com verranno utilizzati come parametri booleani per attivare selettivamente un comando (vedi simulink)
        xmax=0.25;
elseif a==4
        Com4=1;
        Com1=0; Com2=0; Com3=0; Com5=0; Com6=0;
        xmax=0.5;
else
        disp('Do a valid choice!')
        clear
end

%% Nominal condition

 		F=1;
		B=1;
		Na=1;
		Nb=1;
		Nc=1;
		Z=0;
		phi=0;
		G=0.5;

        run ('EMA_Re_DAT_NC')
        sim('EMA_Re_EVO'); 
        
        load('I3equiv.mat')
        load('Dati_Simulaz.mat')
        
        %% Figures
        
        figure(1)       %grafico di posizione
        plot(I3equiv(1,:),Comm,I3equiv(1,:),Dati_Simulaz(2,:),'Linewidth',1.5)
        xlim([0,xmax]);
%         ylim([-0.2,1.2])
        xlabel('Time [s]')
        ylabel('User Position [rad]')
        grid on
        hold on
        
        figure(2)       %grafico di velocit
        plot(I3equiv(1,:),w_ref,I3equiv(1,:),DThM,'Linewidth',1.5)
        xlim([0,xmax]);
        xlabel('Time [s]')
        ylabel('Motor speed [rad/s]')
        grid on
        hold on

        figure(3)       %grafico di corrente
        plot(I3equiv(1,:),I_Max*ones(1,50001),I3equiv(1,:),I3equiv(2,:),'Linewidth',1.5)
        xlim([0,xmax]);
        xlabel('Time [s]')
        ylabel('Equivalent current [A]')
        grid on
        hold on
%% Guasti
    
  disp(' ')
    disp('Choose the fault you would like to introduce:')
    disp('1= Friction fault')
    disp('2= Backlash fault ')
    disp('3= Phase A short circuit fault')
    disp('4= Phase B short circuit fault')
    disp('5= Phase C short circuit fault')
    disp('6= Eccentricity parameter fault (zita) ')
    disp('7= Eccentricity phase fault ')
    disp('8= Gain fault ')
    disp(' ')

    b=input('Your choice: ');

    %Imposto i parametri e faccio girare il file dati con guasto
    
% for i=1:4

    if b==1
        F=input('Give a value for the friction [1 - 3] --> [NC - 3*NC]: ');         %Parametro moltiplicativo per l'attrito
        B=1;                                                                        %Parametro moltiplicativo per il backlash
        Z=0;                                                                        %Parametro dipendente dall'entit del guasto per eccentricit
        phi=0;                                                                      %Sfasamento dell'eccentricit del rotore
        G=1;                                                                        %Parametro moltiplicativo per il gain

        if F<1 || F>3
            disp('Do a valid choice!')
            clear
        else    
            run('EMA_Re_DAT')
        end
    elseif b==2
        F=1;
        B=input('Give a value for the backlash [1 - 100] --> [NC - 100*NC]: ');
        Z=0;
        phi=0;
        G=1;

        if B<1 || B>100
            disp('Do a valid choice!')
            clear
        else    
            run('EMA_Re_DAT')
        end
    elseif b==3
        F=1;
        B=1;
        Na=input('Give a value for the phase A short-circuit [1 - 0] --> [0% - 100%]: ');
        Nb=1;
        Nc=1;
        Z=0;
        phi=0;
        G=1;

        if Na<0 || Na>1
            disp('Do a valid choice!')
            clear
        else    
            run('EMA_Re_DAT2')
        end
    elseif b==4
        F=1;
        B=1;
        Na=1;
        Nb=input('Give a value for the phase B short-circuit [1 - 0] --> [0% - 100%]: ');
        Nc=1;
        Z=0;
        phi=0;
        G=1;

        if Nb<0 || Nb>1
            disp('Do a valid choice!')
            clear
        else    
            run('EMA_Re_DAT2')
        end
    elseif b==5
        F=1;
        B=1;
        Na=1;
        Nb=1;
        Nc=input('Give a value for the phase C short-circuit [1 - 0] --> [0% - 100%]: ');
        Z=0;
        phi=0;
        G=1;

        if Nc<0 || Nc>1
            disp('Do a valid choice!')
            clear
        else    
            run('EMA_Re_DAT2')
        end
    elseif b==6
        F=1;
        B=1;
        Z=input('Give a value for the Z [0 - 0.42]: ');
        phi=0;
        G=1;

        if Z<0 || Z>0.42
            disp('Do a valid choice!')
            clear
        else    
            run('EMA_Re_DAT')
        end
    elseif b==7
        F=1;
        B=1;
        Z=0;
        phi=input('Give a value for the eccentricity phase [-pi - +pi]: ');
        G=1;

        if phi<-pi || phi>pi
            disp('Do a valid choice!')
            clear
        else    
            run('EMA_Re_DAT')
        end
    elseif b==8
        F=1;
        B=1;
        Z=0;
        phi=0;
        G=input('Give a value for the gain [0.5 - 1.5] --> [0.5*NC - 1.5*NC]: ');

        if G<0.5 || G>1.5
            disp('Do a valid choice!')
            clear
        else    
            run('EMA_Re_DAT')
        end
    else 
        disp('Do a valid choice!')
        clear
    end
    
            sim('EMA_Re_EVO'); 
        
        load('I3equiv.mat')
        load('Dati_Simulaz.mat')
        
        figure(1)       %grafico di posizione
        plot(I3equiv(1,:),Dati_Simulaz(2,:),'Linewidth',1.5)
        xlim([0,xmax]);
        xlabel('Time [s]')
        ylabel('User Position [rad]')
        hold on
        
        
        figure(2)       %grafico di velocit
        plot(I3equiv(1,:),DThM,'Linewidth',1.5)
        xlim([0,xmax]);
        xlabel('Time [s]')
        ylabel('Motor speed [rad/s]')
        hold on
        

        figure(3)       %grafico di corrente
        plot(I3equiv(1,:),I3equiv(2,:),'Linewidth',1.5)
        xlim([0,xmax]);
        xlabel('Time [s]')
        ylabel('Equivalent current [A]')
        hold on
        
% end

